#include "stdafx.h"
#include "mttermex.h"

using namespace XNSNET::Collections;
using namespace System;
using namespace System::Windows::Forms;
using namespace MetaTrader;
using namespace MetaTrader::Windows;

bool RetWindowException( Exception^ e ) {
	return ( (gcnew WindowException( e ))->ShowDialog( MainWindow::Current ) == DialogResult::Retry );
}

void ZeroString128( char* p ) {
	for( int i = 0; i < 16; i++ ) {
		((int*)p)[ i ] = 0x20202020;
	}
	p[ 128 ] = 0x00;
}

//MTTERMEX BOOL WINAPI ContextInitialize( char* iContext, char* iSymbol ) {
//Retry:
//	try {
//		Global::Context->Append( (IntPtr)iContext );
//		iContext[ 0 ] = 0x00;
//		Global::WindowControl();
//		return TRUE;
//	} catch( Exception^ e ) {
//		if ( RetWindowException( e ) ) goto Retry;
//	}
//	return FALSE;
//}
//
//MTTERMEX BOOL WINAPI ContextFinalize( char* iContext ) {
//Retry:
//	try {
//		Global::Context->Remove( (IntPtr)iContext );
//		ZeroString128( iContext );
//		Global::WindowControl();
//		return TRUE;
//	} catch( Exception^ e ) {
//		if ( RetWindowException( e ) ) goto Retry;
//	}
//	return FALSE;
//}

MTTERMEX BOOL WINAPI ClasterInitialize( char* iContext, char* iSymbol, int iDigits, int iSpread, double iPoint ) {
Retry:
	try {
		Context^ context = Global::Context->Append( (IntPtr)iContext );
		if ( context->Claster == nullptr ) {
			Claster^ claster = Global::Claster->Append( context, gcnew String( iSymbol ), iDigits, iSpread, iPoint );
		}
		iContext[ 0 ] = 0x00;
		Global::WindowControl();
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ClasterUpdate( char* iContext, double iBid, char* iSrv ) {
Retry:
	try {
		Context^ context = Global::Context[ (IntPtr)iContext ];
		if ( context->Claster == nullptr ) return FALSE;
		if ( context->Claster->Session->First->Context != context ) return FALSE;
		context->Claster->Ticks->Add( DateTime::UtcNow, iBid, DateTime::Parse( gcnew String( iSrv ) ) );
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}

MTTERMEX BOOL WINAPI ClasterFinalize( char* iContext ) {
Retry:
	try {
		Global::Context->Remove( (IntPtr)iContext );
		ZeroString128( iContext );
		return TRUE;
	} catch( Exception^ e ) {
		if ( RetWindowException( e ) ) goto Retry;
	}
	return FALSE;
}