﻿namespace MetaTrader {

	using System;
	using System.Reflection;
	using XNSNET.Collections;

	public class ComparePairCollection: TemplatedList<ComparePairCollection, ComparePair> {

		public readonly CompareMono Mono;

		internal ComparePairCollection( CompareMono iMono )
			: base() {
			Mono = iMono;
		}

		public ComparePair this[ CompareMono iMono ] {
			get {
				ComparePair _Next = this.First;
				ComparePair _Item;
				while ( _Next != null ) {
					_Item = _Next;
					_Next = _Next.Next;
					if ( _Item.Mono == iMono )
						return _Item;
				}
				return null;
			}
		}

		public ComparePair Append( CompareMono iMono ) {
			if ( iMono == null )
				throw new ArgumentNullException();
			if ( iMono == Mono )
				throw new ArgumentException();
			ComparePair _Item = this[ iMono ];
			if ( _Item != null ) return _Item;
			return AddFinal( new ComparePair( iMono ) );
		}

		public ComparePair Remove( CompareMono iMono ) {
			if ( iMono == null )
				throw new ArgumentNullException();
			ComparePair _Item = this[ iMono ];
			if ( _Item != null ) {
				Remove( _Item );
			}
			return _Item;
		}

		public ComparePair[] Array {
			get {
				ComparePair[] _Array = new ComparePair[ Count ];
				int _Index = 0;
				ComparePair _Item = this.First;
				while ( _Item != null ) {
					_Array[ _Index ] = _Item;
					_Item = _Item.Next;
					_Index++;
				}
				return _Array;
			}
		}

	}

	public class ComparePair: TemplatedItem<ComparePairCollection, ComparePair> {

		public readonly CompareMono Mono;
		public Claster Claster;

		internal ComparePair( CompareMono iMono )
		  : base() {
			Mono = iMono;
			Claster = null;
		}

		public override void OnRemoved() {
			if ( Claster != null ) {
				Global.Compare.RemoveClaster( Claster );
				Claster = null;
			}
		}

	}

}