﻿namespace MetaTrader {

	using System;
	using System.Reflection;
	using XNSNET.Collections;

	public class TickCollection: TemplatedList<TickCollection, Tick> {

		internal readonly Claster Claster;
		internal int MaxCount = 999999;

		internal TickCollection( Claster iClaster, int iMaxCount )
			: base() {
			Claster = iClaster;
			if ( iMaxCount > 0 && iMaxCount < 1000000 )
				MaxCount = iMaxCount;
		}

		public Tick Add( DateTime iUtc, double iBid, DateTime iSrv ) {
			while ( Count >= MaxCount ) {
				Remove( First );
			}
			return AddFinal( new Tick( iUtc, iBid, iSrv ) );
		}

	}

	public class Tick: TemplatedItem<TickCollection, Tick> {

		public readonly DateTime Utc;
		public readonly double Bid;
		public readonly DateTime Srv;
		
		public double Ask {
			get {
				return Bid + ( List.Claster.Point * List.Claster.Spread );
			}
		}

		internal Tick( DateTime iUtc, double iBid, DateTime iSrv )
			: base() {
			Utc = iUtc;
			Bid = iBid;
			Srv = iSrv;
		}

	}

}