using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MetaTrader.Windows {
	public partial class WindowExtension: Form {
		public WindowExtension() {
			InitializeComponent();
		}

		private void StateIcon_MouseDoubleClick( object sender, MouseEventArgs e ) {
			if ( this.WindowState != FormWindowState.Minimized ) {
				this.WindowState = FormWindowState.Minimized;
				this.Visible = false;
			} else {
				this.Visible = true;
				this.WindowState = FormWindowState.Maximized;
				this.Activate();
			}
		}

		private void WindowExtension_FormClosing( object sender, FormClosingEventArgs e ) {
			e.Cancel = true;
			this.WindowState = FormWindowState.Minimized;
			this.Visible = false;
		}

		private void WindowExtension_Load( object sender, EventArgs e ) {

		}

		private void WindowExtension_Shown( object sender, EventArgs e ) {
			this.Visible = false;
		}

		private void MenuInfoClasters_Click( object sender, EventArgs e ) {
			new WindowSymbols().Show( this );
		}

		private void MenuInfoCompare_Click( object sender, EventArgs e ) {
			new WindowCompare().Show( this );
		}
	}
}